
class Cover
  def initialize(inputStream, path, mimeType)
    if nil != inputStream
      @data = inputStream.read
    else
      @data = nil
    end
    @path = path
    @mimeType = mimeType
  end

  def path 
    @path
  end

  def inspect
    info = []
    if nil != @data
      info.push('size=' + @data.length.to_s)
    else
      info.push('empty')
    end
    if nil != @path
      info.push('path="' + @path + '"')
    end
    if nil != @mimeType
      info.push('mimeType="' + @mimeType + '"')
    end
    return '(Cover:' + info.join(',') + ')'
  end

  def read_image(filename)
    open(filename, 'rb') do |fd|
      @data = fd.read()
    end
  end

  def to_s
    return inspect
  end

  def write_image(outputDir, filename)
    open(outputDir + '/' + filename, 'wb') do |fd|
      fd.write(@data)
    end
    return filename, @mimeType
  end

  protected
  def getExt
    pos = @path.rindex('.')
    if nil == pos
      return '.img'
    end
    return @path.slice(pos, @path.length)
  end
end

