require 'navigator'
require 'page'
require 'store'
require 'walkdir'

outputDir = 'output'

book_ids = []
imageCount = 0

def handleArg(arg)
  if "--purge" == arg
    puts 'Purging database...'
    @store.dropSchema()
  elsif arg.start_with?("--")
    abort('ERROR:  Unrecognized option "' + arg + '".')
  end
end

@store = Store.new()
@store.connect()

for arg in ARGV
  handleArg(arg)
end

@store.init_db()

for arg in ARGV
  if ! arg.start_with?("--")
    puts 'Scanning directory "' + arg + '"...'
    w = WalkDir.new(@store, arg)
    book_ids += (w.books)
  end
end

puts 'Creating output...'

navigator = Navigator.new(@store)
navigator.write_atoz_pages()
navigator.write_series_listing()
navigator.write_dewey()

@store.disconnect()

